//+------------------------------------------------------------------+
//|                                                 Normalize Volume |
//|                                           2019 - Litoral Trading |
//|                       https://www.mql5.com/pt/users/thiagoduarte |
//|                                                                  |
//| 22/Jul/2019 - v1.0: Release                                      |
//|                                                                  |
//|                                                                  |
//| This function is integrated with others various functions on our |
//| Symbol Trade Made Simple library. Check it out!                  |
//+------------------------------------------------------------------+
#property library
#property version   "1.0"

#include <Trade\AccountInfo.mqh>

CAccountInfo myaccount;

double NormalizeVolume(double volume)
  {
    double resultado = 0;
    double LoteMin = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
    double LoteMax = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);
    double LotePasso = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
    if (volume > 0)
      {

        volume = MathMax(LoteMin,volume);
        volume = LoteMin+NormalizeDouble((volume-LoteMin)/LotePasso,0)*LotePasso;
        resultado = MathMin(LoteMax,volume);
      }
    else
      {
        resultado = LoteMin;
        double compra_margem= myaccount.FreeMarginCheck(_Symbol,ORDER_TYPE_BUY,resultado,SymbolInfoDouble(_Symbol,SYMBOL_ASK));
        double venda_margem = myaccount.FreeMarginCheck(_Symbol,ORDER_TYPE_SELL,resultado,SymbolInfoDouble(_Symbol,SYMBOL_BID));
        if (compra_margem < 0 || venda_margem < 0)
          {
            if (resultado > LoteMin)
              {
                resultado = resultado*myaccount.FreeMargin()/(myaccount.FreeMargin()-MathMin(compra_margem,venda_margem));
                resultado = NormalizeVolume(resultado);
              }
            else {resultado = 0;}
          }
      }
    return(NormalizeDouble(resultado,2));
  }